﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG1.Ex08.Mathematics;
using CG1.Ex08.Rasterization;
using CG1.Ex08.Geometry;
using System.Drawing;

namespace CG1.Ex08.Geometry
{
	public class Polygon {
        //Info: Properties from last exercises - clipping
        public bool Closed = false;
        private List<Edge> Edges = new List<Edge>();
        private Vector4 Prev = new Vector4(-1, -1, -1);
        private Vector4 First;

		public void TryAddVertex(Vector4 point)
		{
            if(Prev.X == -1)
            {
                First = point;
                Prev = point;
            }
            else
            {
                Vector4 d = point - First;
                if (d.Length < 5)
                {
                    Edge e = new Edge(Prev, First);
                    Edges.Add(e);
                    Closed = true;
                    Prev = new Vector4(-1, -1, -1);
                }
                else
                {
                    Edge e = new Edge(Prev, point);
                    Edges.Add(e);
                    Prev = point;
                }
            }
		}


        public void Scan(Bitmap Image)
        {
            //ToDo: Implement scanline algorithm
            //Info: Here you can start to scan the polygon
        }

		public void Draw(Bitmap Image)
		{
            foreach (Edge e in Edges)
                e.Draw(Image);
		}

	}
}
